﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using TodoList.Models;
using Xamarin.Forms;
using XamarinToolkit.Mvvm;
using TodoList.Views;
using TodoList.Controls;
using System.Threading.Tasks;

namespace TodoList.ViewModels
{
    public class CategoriesViewModel : ViewModelBase
    {
        private ObservableCollection<TodoCategory> _categories = new ObservableCollection<TodoCategory>();

        public ObservableCollection<TodoCategory> Categories
        {
            get => _categories;
            set
            {
                _categories = value;
                OnPropertyChanged();
            }
        }

        private TodoCategory selectedCategory;

        public TodoCategory SelectedCategory
        {
            get => selectedCategory;
            set
            {
                selectedCategory = value;
                OnPropertyChanged();
            }
        }

        private Command<string> _addCategoryCommand;

        public Command<string> AddCategoryCommand => _addCategoryCommand ?? (_addCategoryCommand = new Command<string>(AddCategory));

        private Command<TodoCategory> navigateToCategoryTodosCommand;

        public Command<TodoCategory> NavigateToCategoryTodosCommand => navigateToCategoryTodosCommand ?? (navigateToCategoryTodosCommand = new Command<TodoCategory>(NavigateToCategoryTodos));

        private Command<TodoCategory> _deleteCategoryCommand;

        public Command<TodoCategory> DeleteCategoryCommand => _deleteCategoryCommand ?? (_deleteCategoryCommand = new Command<TodoCategory>(DeleteCategory));

        private async void AddCategory(string name)
        {
            if (string.IsNullOrEmpty(name)) return;

            var newCategory = new TodoCategory()
            {
                Name = name
            };
        }

        private async void DeleteCategory(TodoCategory category)
        {
        }

        private async void NavigateToCategoryTodos(TodoCategory category)
        {
            await Navigation.PushAsync(new TodosView()
            {
                Title = category.Name,
                ViewModel = new TodosViewModel()
                {
                    Category = category
                }
            });
        }
    }
}