﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using System.Threading.Tasks;
using TodoList.Models;
using Xamarin.Forms;
using XamarinToolkit.Mvvm;

namespace TodoList.ViewModels
{
    public class TodosViewModel : ViewModelBase
    {
        private TodoCategory _category;

        public TodoCategory Category
        {
            get => _category;
            set
            {
                _category = value;
                OnPropertyChanged();
            }
        }

        private ObservableCollection<TodoItem> _items = new ObservableCollection<TodoItem>();

        public ObservableCollection<TodoItem> Items
        {
            get => _items;
            set
            {
                _items = value;
                OnPropertyChanged();
            }
        }

        private Command<string> _addItemCommand;

        public Command<string> AddItemCommand => _addItemCommand ?? (_addItemCommand = new Command<string>(AddItem));

        private Command<TodoItem> _deleteItemCommand;

        public Command<TodoItem> DeleteItemCommand => _deleteItemCommand ?? (_deleteItemCommand = new Command<TodoItem>(DeleteItem));

        private async void AddItem(string text)
        {
            if (string.IsNullOrEmpty(text)) return;

            var newItem = new TodoItem()
            {
                CategoryId = Category.Id,
                Text = text
            };
        }

        private async void DeleteItem(TodoItem item)
        {
        }

        public async Task UpdateItem(TodoItem item)
        {
        }
    }
}